Subject: Re: linux-next: Tree for July 30

From: Andrew Morton <[email-masked]>
Date: Thu, 31 Jul 2008 11:26:54 -0700

On Thu, 31 Jul 2008 14:17:31 -0400 Dmitry Torokhov <[email-masked]> wrote:

> On Thu, Jul 31, 2008 at 10:44:37AM -0700, Andrew Morton wrote:
> > On Thu, 31 Jul 2008 11:56:48 -0400 Dmitry Torokhov <[email-masked]> wrote:
> > 
> > > On Thu, Jul 31, 2008 at 05:36:16PM +0200, Bartlomiej Zolnierkiewicz wrote:
> > > > On Thu, Jul 31, 2008 at 4:07 PM, Dmitry Torokhov
> > > > <[email-masked]> wrote:
> > > > > On Wed, Jul 30, 2008 at 11:10:29PM -0700, Andrew Morton wrote:
> > > > >> On Wed, 30 Jul 2008 17:06:35 +1000 Stephen Rothwell <[email-masked]> wrote:
> > > > >>
> > > > >> > I have created today's linux-next tree at
> > > > >> > git://git.kernel.org/pub/scm/linux/kernel/git/sfr/linux-next.git
> > > > >>
> > > > >> The X server broke on my FC8 t61p thinkpad.  Mainline is OK.
> > > > >>
> > > > >> Various information is at http://userweb.kernel.org/~akpm/mo/
> > > > >>
> > > > >> I'm suspecting the input layer - my synaptics device seems to have
> > > > >> disappeared?  See http://userweb.kernel.org/~akpm/mo/Xorg-log-diff.txt
> > > > >>
> > > > >
> > > > > I think this patch should help with Synaptics:
> > > > 
> > > > Which unfortunately doesn't help all people running with older synaptics
> > > > user-space after commit 0571c5d20aca71c735222132b02aebddf593045c
> > > > ("Input: expand keycode space").
> > > > 
> > > > Can't this be solved without breaking Xorg on newer kernels running
> > > > older synaptics?
> > > > 
> > > 
> > > No. The X driver is broken. It tells kernel to use buffer bugger than
> > > allocated and gets its stack smashed. Tslib has also soma funkiness
> > > in the ioctl handling as well... *shrug*
> > > 
> > > We have a couple months to get distros updated...
> > > 
> > 
> > aaarrrrgggggghhh.  I don't think this is practical.  This means that
> > (for example) FC5 machines (of which I happen to have one) are dead. 
> > And lots of other older-distro-based systems.
> > 
> > Is there some userspace workaround which doesn't require an X server
> > update?
> > 
> > Surely it must be possible to make the kernel contiue to support these
> > servers?
> > 
> 
> Andrew,
> 
> It is not like we broke ABI here. The progam (synaptics driver) had a
> grave bug. Older kernels happened to paper over the bug because they
> did not fill the whole buffer that was advertised as available. Now
> that we have more data to report the bug bit us. What do you want me
> to do?

Paper over the bug again.  When it happens, spit out a loud printk.

> Synaptics driver is a small package and takes 2 minutes to recompile.
> You don't have to update entire X server with it (in fact I don't think
> it is even part of X distribution because it is GPL).

What proportion of the X servers out there did we just break?

Was the crash I saw due to this?

Where would I (Aunt Tillie running FC5) go to find out how to fix my
machine up again?